List = {}


--[[ Public ]]
function List.New ()
	--[[ indexăe[u邱Ƃɒ ]]
	return { first=0, last=-1, count=0, index={ first=0, last=-1} }
end

--[[ Public ]]
function List.SetLeft(list, key, value)
	if list[key]==nil then list.first = list.first-1 end
	list[key] = value
	
	list.count = list.count+1
	
	List.PushLeft(list.index, key)
end

--[[ Public ]]
function List.SetRight(list, key, value)
	if list[key]==nil then list.last = list.last+1 end
	list[key] = value
	
	list.count = list.count+1
	
	List.PushRight(list.index, key)
end

--[[ Public ]]
function List.Get(list, key)
	return list[key]
end

--[[ Public ]]
function List.GetLeft(list, index)
	if index==nil then Index = 1 end
	local temp = List.GetIndex(list, index)
	if list[temp]==nil then
		return temp
	else
		return list[temp]
	end
end

--[[ Public ]]
function List.GetRight(list, index)
	if index==nil then index = -1 end
	local temp = List.GetIndex(list, index)
	if list[temp]==nil then
		return temp
	else
		return list[temp]
	end
end

--[[ Public ]]
function List.GetIndex(list, index)
	local first
	local last
	local res
	
	if 0 < index then
		first	= list.index.first-1
		res	= first + index
	else
		last	= list.index.last+1
		res	= last + index
	end

	return list.index[res]
end

--[[ Public ]]
function List.IsItem(Index)
	if Index=="first" or Index=="last" or Index=="index" or Index=="count" then
		return false
	else
		return true
	end
end


--------------------


--[[ Public ]]
function List.PushLeft (list, value)
	local first = list.first-1
	list.first  = first
	list[first] = value
	if list.index~=nil then
		List.PushLeft(list.index, value)
	end
	
	if list.count~=nil then
		list.count = list.count+1
	end
end

--[[ Public ]]
function List.PushRight (list, value)
	local last = list.last + 1
	list.last = last
	list[last] = value
	if list.index~=nil then
		List.PushRight(list.index, value)
	end
	
	if list.count~=nil then
		list.count = list.count+1
	end
end

--[[ Public ]]
function List.PopLeft (list)
	local first = list.first
	if first > list.last then
		return nil
	end
	
	if list.index~=nil then
		list.index[ list.index.first ] = nil
	end
	
	local value = list[first]
	list[first] = nil         -- to allow garbage collection
	list.first = first+1
	
	if list.count~=nil then
		list.count = list.count-1
	end
	
	return value
end

--[[ Public ]]
function List.PopRight (list)
	local last = list.last
	if list.first > last then
		return nil
	end
	
	if list.index~=nil then
		list.index[ list.index.last ] = nil
	end
	
	local value = list[last]
	list[last] = nil
	list.last = last-1
	
	if list.count~=nil then
		list.count = list.count-1
	end
	
	return value
end

--[[ Public ]]
function List.Clear (list)
--[[
	for i,v in ipairs(list) do
		list[i] = nil
	end
	--
		if List.size(list) == 0 then
			return
		end
		local first = list.first
		local last  = list.last
		for i=first, last do
			list[i] = nil
		end
	--
--]]
	list = nil
	list = List.New()
end

--[[ Public ]]
function List.Size (list)
	local size = list.last - list.first + 1
	return size
end

--[[ Public ]]
function List.Count(list)
	if list==nil then return 0 end
	
	return list.count
	--[[
	local num = 0
	for i, val in pairs(list) do
		num = num+1
	end
	
	return num
	]]
end
-------------------------------------------------
 
