--[[ Actor ]]
Party = {}


--[[ Public Parameter ( FriendList ) ]] 
Party.PartyList	= {}	-- ꎞIXg


-------------


--[[ Public ]]
function Party.GetParty(ActorID)
	return Party.PartyList[ActorID]
end

--[[ Public ]]
function Party.SetParty()
	Trace("SetParty", "Start")
	
	local Actors = GetActors()
	
	for i, ActorID in pairs(Actors) do
		local DistanceFromOwner = Position.GetDistanceFromOwner(ActorID)
		local ActorIsPlayer =  Actor.IsPlayer(ActorID)
		
		Trace(DistanceFromOwner .. " : " .. ActorID , "", TRACE_PARAM)
		if (DistanceFromOwner<PARTY_DISTANCE) and ActorIsPlayer then
			local Friend = PlayerDataAccesser.GetFriend(ActorID)
			if Friend then
				Party.PartyList[ActorID] = {Name=Friend.Name}
			else
				Party.PartyList[ActorID] = {Name="H"}
			end
		end
	end
	
	Trace("SetParty", "End")
end
