--[[ Finding ]]
--[[ List ]]
--[[ Actor ]]
ifSearch = {}
local SearchAction = {}


local TickStamp			= 0

---------------------


--[[ Public ]]
function ifSearch()
	SearchAction.SearchActors()	
end

-------------------


--[[ Private ]]
function SearchAction.SearchActors()
	Trace("Search","Start")
	
	if 5 < TICK_TIME-TickStamp   then
		Finding.RenewActorData()
		TickStamp	= TICK_TIME
	end
	
	local Actors = GetActors()
	local EnemyIDList		= List.New()
	local FriendIDList		= List.New()
	local UnknownIDList	= List.New()
	
	local ActorID
	local ActorData
	local TargetID
	local TargetData
	local Danger
	
	--gPActorƂăf[^o^
	for i, ActorID in pairs(Actors) do
		--IDActor𒲂ׂ
		ActorData = Finding.GetActorData(ActorID)
		if IsTrue(ActorData) then
			ActorData = Actor.Update(ActorData)
		else
			ActorData = Actor.New(ActorID)
		end
		Finding.SetActorData(ActorData)
		
		if ActorData.IFF==IFF_ENEMY then
			List.PushRight(EnemyIDList, ActorID)
			
		elseif ActorData.IFF==IFF_UNKNOWN then
			List.PushRight(UnknownIDList, ActorID)
			
		elseif ActorData.IFF==IFF_FRIEND then
			List.PushRight(FriendIDList, ActorID)
			
		end
		
		--Actor̃^[Qbg𒲂ׂ
		TargetID = ActorData.Target
		if IsTrue(TargetID) then
			--ActorTargetĂ
			TargetData = Finding.GetActorData(TargetID)
			if TargetData==nil then
				TargetData = Actor.New(TargetID)
			else
				TargetData = Actor.Update(TargetData)
			end
			
			-----------------
			List.PushRight(TargetData.EnemyList, ActorData.ID)
			
			--Target 猩 Actor ̊댯x𒲂ׂ
			Danger	= -Evaluation.EnemyEvaluation(TargetData, ActorData)
			if 0 < Danger then
				TargetData.DangerLevel = TargetData.DangerLevel + Danger
			end
			-----------------
			Finding.SetActorData(TargetData)
			Trace(ActorData.IFF .. ActorData.ID .. "  " .. TargetData.IFF .. TargetData.ID, "", TRACE_PARAM)
			
		else
			Trace(ActorData.IFF .. ActorData.ID .. "   NoTarget", "", TRACE_PARAM)
			
		end
		Trace("", "", TRACE_PARAM )
	end
	
	Finding.SetActorIDList(ACT_ENEMY, EnemyIDList)
	Finding.SetActorIDList(ACT_FRIEND, FriendIDList)
	Finding.SetActorIDList(ACT_UNKNOWN, UnknownIDList)
	
	Trace("Search","End")
end
