local TacActEngage = {}


--------------------


--[[ Public ]]
function ifEngage()
	TacActEngage.Run()
end


--------------------


--[[ Private ]]
function TacActEngage.Run()
	Trace("TacActEngage")
	
	local PrimaryTarget	= List.Get(My.PriorityList, ACT_ENEMY)
	ifTarget(PrimaryTarget.ID)
	
	local Range = My.Character.HoldRange
	local TargetDistance	= Position.GetDistanceFromMe(PrimaryTarget.ID)
	
	if Range+1 < TargetDistance then
		ifChase(PrimaryTarget.ID, Range)
		
	--elseif TargetDistance <= Range-1 then
		
	else
		local Role	= My.Character.Role
		if Role==ROLE_ATKF then
			TacActEngage.InFight(PrimaryTarget.ID)
			
		elseif Role==ROLE_ATKS then
			TacActEngage.Skill(PrimaryTarget.ID)
			
		elseif Role==ROLE_DECOY then
			TacActEngage.Decoy(PrimaryTarget.ID)
			
		elseif Role==ROLE_HEAL then
			TacActEngage.Heal(PrimaryTarget.ID)
			
		elseif Role==ROLE_GUARD then
			TacActEngage.Guard(PrimaryTarget.ID)
		end
	end
end

--[[ Private ]]
function TacActEngage.InFight(TargetID)
end

--[[ Private ]]
function TacActEngage.Skill(TargetID)
end

--[[ Private ]]
function TacActEngage.Decoy(TargetID)
end

--[[ Private ]]
function TacActEngage.Heal(TargetID)	
end

--[[ Private ]]
function TacActEngage.Guard(TargetID)	
end

