--[[ gpGfB^ SciTE  TAB=2 ]]


--[[ Private ]]
local ShowPackage = false

local ImportSpanTick	= 500
local ImportFileNum	= 3
local LiblalyComplete	= false

local TotalFileNum		= 0
local LoadedFileNum	= 0
local PrevImportTime	= 0


--[[ ǂݍޏԂɒӁB@KvłقǏɂB
		/
		/Liblaly
		/User
		/Main
		/Main/TacticalAction
]]

local ImportLuaList = {
	"PublicParameter",
	
	"Liblaly/Tracer",
	"Liblaly/List",
	"Liblaly/Ask",
	"Liblaly/My",
	"Liblaly/Position",
	"Liblaly/Actor",
	"Liblaly/Evaluation",
	"Liblaly/MobData",
	"Liblaly/MobDataAccesser",
	"Liblaly/ExceptDataAccesser",
	"Liblaly/PlayerDataAccesser",
	"Liblaly/SkillDataAccesser",
	"Liblaly/Party",
	"Liblaly/TargetPriority",
	"Liblaly/Finding",
	"Liblaly/math",
	
	"User/UserParameter",
	"User/HomCharacter",
	"User/FriendList",
	"User/ExceptList",	
	
	"Main/SearchAction",
	"Main/MoveAction",
	"Main/AttackAction",
	"Main/DecisionAI",
	"Main/BehaviorAI",
	
	"Main/TacticalAction/-/Chase",
	"Main/TacticalAction/-/Decoy",
	"Main/TacticalAction/-/Engage",
	"Main/TacticalAction/-/Guard",
	"Main/TacticalAction/-/Stealth",
	"Main/TacticalAction/-/Support",
}

--[[ Public ]]
function ImportLua(myid)
	if not IMPORT_COMPLETE then		
		if TotalFileNum == 0 then
			if DEBUG_MODE then
				TraceAI("DEBUG_MODE : true")
			end
			TotalFileNum		= GetFileNum(ImportLuaList)
			--FileNumInCycle	= TotalFileNum / ImportFileNum
			FileNumInCycle	= ImportFileNum
		end
		
		if LOAD_TEST or (PrevImportTime+ImportSpanTick < TICK_TIME) then			
			local LoadEnd = LoadedFileNum + FileNumInCycle
			if TotalFileNum < LoadEnd then LoadEnd = TotalFileNum end
			LoadedFileNum = LoadedFileNum + 1
			
			TraceAI(TICK_TIME .. "  Now Importing")
			
			local path
			for i=LoadedFileNum,  LoadEnd do
				path = ImportLuaList[i]
				
				if string.sub(path, 1, 20)=="Main/TacticalAction/" then
					if 		 Actor.IsLif(myid)		then path = (string.gsub(path, "-", "LIF"))
					elseif Actor.IsAmistr(myid)	then path = (string.gsub(path, "-", "AMISTR")) 
					elseif Actor.IsFilir(myid)		then path = (string.gsub(path, "-", "FILIR")) 
					elseif Actor.IsVanilmirth(myid)	then path = (string.gsub(path, "-", "VANILMIRTH")) 
					end
				end
				import(path)
				LoadedFileNum = i
			end
			
			if TotalFileNum < LoadedFileNum+1 then
			TraceAI(TICK_TIME .. "  Import Complete")
				IMPORT_COMPLETE = true
			else
				PrevImportTime	= TICK_TIME
			end
			
		end
	end
end


--[[ Private ]]
function import( package )
	if type( package ) == "string" then
		if ShowPackage then 
			TraceAI(TICK_TIME .. "   " .. package)
		end
		dofile( PACKAGE_DIR.."/"..package..PACKAGE_EXT )
		
	elseif type( package ) == "table" then
		for i, v in pairs( package ) do
			import( v )
		end
		
	else assert(nil) end
end

--[[ Private ]]
function GetFileNum( package )
	local FileNum = 0
	if type( package ) == "string" then
		FileNum = FileNum+1
		
	elseif type( package ) == "table" then
		for i, pac in pairs( package ) do
			if type( package ) == "string" then
				FileNum = FileNum+1
			else
				FileNum = FileNum + GetFileNum( pac )
			end
		end
		
	else assert(nil) end
	
	return FileNum
end

---------------------
